unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, TeEngine, TeeProcs, Chart, DB, DBTables, Series, Grids, DBGrids;

type
  TfrmZoom = class(TForm)
    Chart1: TChart;
    Panel1: TPanel;
    Memo1: TMemo;
    Button1: TButton;
    Table1: TTable;
    DBGrid1: TDBGrid;
    DataSource1: TDataSource;
    Button2: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Chart1Zoom(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    tcs, tcs1, tcs2: TChartSeries;
    { Public declarations }
  end;

var
  frmZoom: TfrmZoom;

implementation

{$R *.dfm}

procedure TfrmZoom.Button1Click(Sender: TObject);
begin
  Memo1.Lines.Clear;
  Table1.Close;
  if Assigned(tcs)  then tcs.Clear;
  if Assigned(tcs1) then tcs1.Clear;
  if Assigned(tcs2) then tcs2.Clear;
  Table1.TableName:= 'C:\Delphi\Zoom\Zoom.dbf';
  Table1.Open;
  Table1.DisableControls;
  try
    if not Assigned(tcs)  then tcs:= TPointSeries.Create(nil);
    if not Assigned(tcs1) then tcs1:= TPointSeries.Create(nil);
    if not Assigned(tcs2) then tcs2:= TPointSeries.Create(nil);
    tcs2.VertAxis:= aRightAxis;
    while not(Table1.Eof) do begin
      tcs.AddXY(Table1.Fields[0].AsFloat,  Table1.Fields[1].AsFloat);
      tcs1.AddXY(Table1.Fields[0].AsFloat, Table1.Fields[2].AsFloat);
      tcs2.AddXY(Table1.Fields[0].AsFloat, Table1.Fields[3].AsFloat);
      Table1.Next;
    end;
    Chart1.AddSeries(tcs);
    Chart1.AddSeries(tcs1);
    Chart1.AddSeries(tcs2);
  finally
    Table1.EnableControls;
  end;
  Memo1.Lines.Add('Set Zoom window around the upper two series and check the zoom bounds.');
  Memo1.Lines.Add('Clear the zoom and zoom on the lower series and check the zoom bounds.');
  Memo1.Lines.Add('Remove the right axis series and again check the zoom bounds.');
end;

procedure TfrmZoom.Button2Click(Sender: TObject);
begin
  if Chart1.SeriesCount > 2 then
    Chart1.RemoveSeries(tcs2);
end;

procedure TfrmZoom.Chart1Zoom(Sender: TObject);
begin
  Memo1.Lines.Clear;
  Memo1.Lines.Add('Zoom bounds');
  Memo1.Lines.Add('    Left Minimum:   ' + FloatToStr(Chart1.LeftAxis.Minimum));
  Memo1.Lines.Add('    Right Minimum: ' + FloatToStr(Chart1.RightAxis.Minimum));
  Memo1.Lines.Add('');
  Memo1.Lines.Add('    Left Maximum:   ' + FloatToStr(Chart1.LeftAxis.Maximum));
  Memo1.Lines.Add('    Right Maximum: ' + FloatToStr(Chart1.RightAxis.Maximum));
  Memo1.Lines.Add('');
  Memo1.Lines.Add('It appears that the bounds are set for both the left and right');
  Memo1.Lines.Add('axis based upon the last series processed.  If the right axis');
  Memo1.Lines.Add('series is not added to the chart, the axis appears correct but');
  Memo1.Lines.Add('the bounds are still incorrect.');
end;

procedure TfrmZoom.FormDestroy(Sender: TObject);
begin
  Table1.Close;
  Chart1.SeriesList.ClearValues;
end;

end.
